Array	   w;
Array	Gw1,Pw1,Gw2,Pw2,GG,Gw,Gw1inv,Gw2inv,g_delta,ph_n,gain2;
Matrix	An,Bn,Cn;
Matrix	Ap,Bp,Cp,del_a,del_b,del_c,del_d;

//
//  Ťߤ   (1996.6.4)
//
Func void weight_set1()
{	
	Polynomial	s;
	Rational	Wd,Ws,alpha,Ws2;
	Matrix 	ad,bd,cd,dd;
	Integer q;
	s = $;
	
	q = 2;
	do {
		print"\n servo controller or not? (servo: q=1, not: q=2)\n\n";
		read q;
	} while (q != 1 && q != 2);

	Wd = 1.4*(s)^2 / (1.0 + 7.0*s)^2;      // Wd of Case1
	
	if (q == 1) {
		Ws2 = 1.0 / (s+0.001);
		alpha = s / (s+0.001);
		print alpha, Ws2, Wd;
		print Ws2,Wd,alpha -> "Wsdal.mx";
		Ws = Ws2 / alpha;
	} else if (q == 2) {
		Ws = 1.0 / ( s + 0.01 );
		print Wd -> "Wd.mx";
		print Ws -> "Ws.mx";		
		print Ws, Wd;
	}
	
	{Gw1,Pw1} = Bode(Wd,w);
	{Gw2,Pw2} = Bode(Ws,w);
	{Gw2inv,Pw1} = Bode(Wd~,w);
	{Gw1inv,Pw2} = Bode(Ws~,w);
}

Func void weight_set2()
{	
	Polynomial	s;
	Rational	Wd,Ws,alpha,Ws2;
	Matrix 	ad,bd,cd,dd;
	Real T,Kd,Ks;
	Integer q,yorno;
	s = $;
	
	T = 7.0;
	Kd = 1.4;
	Ks = 1.0;
	q = 2;
	do {
		print"\n servo controller or not? (servo: q=1, not: q=2)\n\n";
		read q;
	} while (q != 1 && q != 2);
	
	do {
		read T, Kd, Ks;
		Wd = Kd*(s)^2 / (1.0 + T*s)^2;    // Wd of Case2
		
		if (q == 1) {
			Ws2 = Ks / (s+0.001);
			alpha = s / (s+0.001);
			print Ws2,Wd,alpha -> "Wsdal2.mx";
			print alpha, Ws2, Wd;
			Ws = Ws2 / alpha;
		} else if (q == 2) {
			Ws = Ks / ( s + 0.01 );
			print Wd -> "Wd2.mx";
			print Ws -> "Ws2.mx";		
			print Ws, Wd;
		}
		
		{Gw1,Pw1} = Bode(Wd,w);
		{Gw2,Pw2} = Bode(Ws,w);
		{Gw2inv,Pw1} = Bode(Wd~,w);
		{Gw1inv,Pw2} = Bode(Ws~,w);
		
		{del_a,del_b,del_c,del_d} = TFsub({Ap,Bp,Cp,[0]},{An,Bn,Cn,[0]});
		{g_delta,ph_n} = bode(del_a,del_b,del_c,del_d,1,w);
		gain2 = [[ g_delta ][ Gw1 ]];
		print "\n\n\n\n Delta(Red) and Wd(Green).\n\n";
		mgplot_semilogx(2,w,gain2);
		
		do {
			print " Is Wd ok? (yes: 1 or no:2)\n";
			yorno = 1;
			read yorno;
		} while (yorno != 1 && yorno != 2);
	} while (yorno != 1);
}

//
//	ȿ
//
Func void main()
{
	Matrix	result,z;
	Array	gain,gain1,gain3;
	Array	ph_p,gain_n,gain_p;
	Integer	n1,n2,Case;
	Polynomial	s;
	
	s = $;
	w = logspace(0.001,1000.0);
	read An,Bn,Cn <- "plant.mx";
	Case = 1;
	do {
		print" Case 1 or Case 2 ? \n\n";
		read Case;
	} while (Case != 1 && Case != 2);

	if (Case == 1) {
		read Ap,Bp,Cp <- "jitupla.mx";
		weight_set1();
		print "\n\n Case 1 \n\n\n";
	} else {
		read Ap,Bp,Cp <- "jitu2.mx";
		weight_set2();
		print "\n\n Case 2 \n\n\n";
	}      

	{del_a,del_b,del_c} = TFsub({Ap,Bp,Cp,[0]},{An,Bn,Cn,[0]});
	n1 = Rows(Cn);
	n2 = Rows(Cp);
	z = Z(n1,1);
	{gain_n,ph_n} = bode(An,Bn,Cn,z,1,w);	
	z = Z(n2,1);
	{gain_p,ph_p} = bode(Ap,Bp,Cp,z,1,w);
	{g_delta,ph_n} = bode(del_a,del_b,del_c,z,1,w);
	
	Gw = [[ Gw1inv ][ Gw2inv ]];
	
	print "\n 1/Ws (Red) and 1/Wd (Green).\n\n";
	mgplot_semilogx(2,w,Gw);
	pause;
	
	gain = [[ gain_n ][ gain_p ]];
	print "\n\n\n\n nominal(Red) and real plant(Green).\n\n";
	mgplot_semilogx(1,w,gain);
	pause;
	
	gain2 = [[ g_delta ][ Gw1 ]];
	print "\n\n\n\n Delta(Red) and Wd(Green).\n\n";
	mgplot_semilogx(2,w,gain2);
	pause;
	
//   result = [[ w ][ Gw ][ gain ][ gain2 ]];
//   print result >> "gain_w.mat";	
}




