//
//	ֱ ߥ졼	*/
//
Matrix	A,B,C,Ac,Bc,Cc;
Matrix  Ap,Bp,Cp;
Real	r;
Integer	n,pn,cn;			// ץȤμ

Func void main()
{
	void resp();
	resp();
}			

Func void resp()
{	
	Integer k;				// ǡ
	Matrix x0;
	Array TC,XC,UC,z0;
	Array res,result;
	void diff_eqs(), link_eqs();
	
	read A,B,C <- "plant.mx";
	read Ap,Bp,Cp <- "jitupla.mx";
	read Ac,Bc,Cc <- "K.mx";                        
	
	n = Cols(A);
	pn = Cols(Ap);
	cn = Cols(Ac);
	x0 = Z(n+pn+2*cn,1);	// 
	r = 3.0;
	read r;
	{TC, XC, UC} = Ode45Auto(0.0,10.0,x0,diff_eqs,link_eqs,0.04,0.01,EPS,0.01);
	k = Cols(TC);
	z0 = r * ONE(1,k);
	
	res = [[ UC(3:4,*)	]	
		   [ z0	        ]];
	
	print "\n\n Time response is .. \n";
	print "    Red  : nominal\n";
	print "    Green: real plant\n\n";
	mgplot(2,TC,res);
	pause;
	print "\n\n Input is .. \n\n";
	print "    Red  : nominal\n";
	print "    Green: real plant\n\n";
	mgplot(1,TC,UC(1:2,*));
	pause;
	
//	result = [[ TC ]
//			  [ res ]];
//   print result >> "hinf_n.mat";		
}

Func void diff_eqs(dx,t,x,UY)
	Real	t;
	Matrix	x,dx,UY;
{	
	Real 	un,up,yn,yp,en,ep;
	Matrix  dxn,dxp,dxcn,dxcp,xn,xp,xcn,xcp;
	
	un = UY(1,1);
	up = UY(2,1);
	yn = UY(3,1);
	yp = UY(4,1);
	en = yn - r;
	ep = yp - r;
	xn = x(1:n,1);
	xp = x(n+1:n+pn,1);
	xcn = x(n+pn+1:n+pn+cn,1);
	xcp = x(n+pn+cn+1:n+pn+2*cn,1);
	dxn = A * xn + B * un;     	// Υߥʥξ
	dxp = Ap* xp + Bp* up;		// ¥ץȤξ
	dxcn = Ac * xcn + Bc * en;  // ȥξ
	dxcp = Ac * xcp + Bc * ep;
	dx = [[ dxn ][ dxp ][ dxcn ][ dxcp ]];
}

Func void link_eqs(UY,t,x)
	Real	t;
	Matrix	UY,x;
{
	Matrix	un,up,yn,yp,xn,xp,xcn,xcp;
	
	xn = x(1:n,1);
	xp = x(n+1:n+pn,1);
	xcn = x(n+pn+1:n+pn+cn,1);
	xcp = x(n+pn+cn+1:n+pn+2*cn,1);
	un = Cc*xcn;			// feedback law(nominal)
	up = Cc*xcp;			// feedback law(real)
	yn = C * xn;
	yp = Cp * xp;
	UY = [ [un]',[up]',[yn]',[yp]']';
}
