//
//	ֱ ߥ졼	 (1996.6.6)
// 	with lsim

Matrix	A,B,C,D,Ac,Bc,Cc,An,Bn,Cn1,Dn1,Cn2,Dn2;
Matrix  Ap,Bp,Cp,Dp,Aj,Bj,Cj1,Dj1,Cj2,Dj2;
Real	r,hour;
Integer	n,pn,cn;			

Func void main()
{
	void resp();
	resp();
}			

Func void resp()
{	
	Integer k,ii,Case,para_save;
	Matrix x0;
	Array TC,XC,UC,z0,Yn,Un,Yj,Uj;
	Array res,result,r_array,T,data;
	Real dt;
	void	diff_eqs(), link_eqs();
	
	hour = 20.0;
	ii = 2;
	Case = 1;
	do {
		print"\n Is real plant Case 1 or Case 2?\n\n";
		read Case;
	} while (Case != 1 && Case != 2);

	if (Case == 1) {
		read Ap,Bp,Cp <- "jitupla.mx";
		para_save = 1;
	} else {
		read Ap,Bp,Cp <- "jitu2.mx";
		para_save = 2;
	}      
	
	do {
		print"\n servo controller or not? (servo: ii=1, not: ii=2)\n\n";
		read ii;
	} while (ii != 1 && ii != 2);
	do {
		print"\n Controller is for Case1 or not?\n\n";
		read Case;
	} while (Case != 1 && Case != 2);
	
	if (ii == 2) {
		if (Case == 1) {
			read Ac,Bc,Cc <- "K.mx";                        
		} else {
			read Ac,Bc,Cc <- "K2.mx";                        
		}
	}
	if (ii == 1) {
		if (Case == 1) {
			read Ac,Bc,Cc <- "K_sv.mx";                        
		} else {
			read Ac,Bc,Cc <- "K_sv2.mx";
		}
	}
	read A,B,C <- "plant.mx";
	D = Z(Rows(C),Cols(B));
	Dp= Z(Rows(Cp),Cols(Bp));
	
	n = Cols(A);
	pn = Cols(Ap);
	cn = Cols(Ac);
	x0 = Z(n+pn+2*cn,1);		// 
	r = 3.0;
//   read r;
	dt = 0.1;
	T = [0:hour/dt]*dt;
	r_array = r * ONE(T);
	
	An = [[ A ,   B*Cc ]
		  [ Bc*C, Ac+Bc*D*Cc ]];
	Bn = [[ Z(Rows(A),1) ]
		  [ -Bc ]];
	Cn1= [[ C , D*Cc ]];
	Dn1= Z(Rows(C),1);
	Cn2= [[ Z(1,Cols(C)), Cc ]];
	Dn2= Z(1);
	
	Aj = [[ Ap ,   Bp*Cc ]
		  [ Bc*Cp, Ac+Bc*Dp*Cc ]];
	Bj = [[ Z(Rows(Ap),1) ]
		  [ -Bc ]];
	Cj1= [[ Cp , Dp*Cc ]];
	Dj1= Z(Rows(Cp),1);
	Cj2= [[ Z(1,Cols(Cp)), Cc ]];
	Dj2= Z(1);
	
	{An,Bn} = Discretize(An,Bn,dt);
	{Aj,Bj} = Discretize(Aj,Bj,dt);
	
	{Yn} = dlsim(An,Bn,Cn1,Dn1,r_array);
	{Un} = dlsim(An,Bn,Cn2,Dn2,r_array);
	{Yj} = dlsim(Aj,Bj,Cj1,Dj1,r_array);
	{Uj} = dlsim(Aj,Bj,Cj2,Dj2,r_array);
	
	print"\n\n Red   is time response of nominal.\n";
	print" Green is real plant's.\n";
	print" Blue is reference.\n\n";
	mgplot(1,T,Array([[Yn][Yj][r_array]]));
	pause;
	
	print"\n\n Red   is input in nominal plant.\n";
	print" Green is input in real plant.\n";
	mgplot(2,T,Array([[Un][Uj]]));
	pause;
	data = [[ T ][ Yn ][ Yj ][ Un ][ Uj ][ r_array ]];
	if (para_save == 1) {
		if (Case == 1) {
			if (ii == 1) {
				print data >> "data_11s.mat";
			} else {
				print data >> "data_11.mat";
			}
		} else {
			if (ii == 1) {
				print data >> "data_12s.mat";
			} else {
				print data >> "data_12.mat";
			}
		}
	} else {
		if (Case == 1) {
			if (ii == 1) {
				print data >> "data_21s.mat";
			} else {
				print data >> "data_21.mat";
			}
		} else {
			if (ii == 1) {
				print data >> "data_22s.mat";
			} else {
				print data >> "data_22.mat";
			}
		}
	}
}


