
/*  -*- MaTX -*-
 *
 *  ̾
 *      expm2() - ƥ顼ˤؿ
 *
 *  ڷ
 *      e = expm2(a)
 *         Matrix e;
 *         Matrix a;
 */

Func Matrix expm2(aa)
	Matrix aa;
{
	Matrix a,e,f;
	Integer k,s;

	a = aa;

	// Υब 1/2 ʲˤʤ褦 A  2 ߾ǥ󥰤
	s = Integer(round(log(norm(a,1))/log(2.0) + 1.5));
	if (s < 0) {
		s = 0;
	}
	a = a/2^s;

	// exp(A) Υƥ顼
	e = Z(a);
	f = I(a);
	k = 1;
	while (norm(e+f-e,1) > 0) {
		e = e + f;
		f = a*f/k;
		k = k + 1;
	}

	// 򷫤֤ơ󥰤᤹
	for (k = 1; k <= s; k++) {
		e = e*e;
	}

	return e;
}
